#if !defined(AFX_ADVENTTHREAD_H__8B1329BA_7CF5_4B5D_9CB9_ACC60C9EAD53__INCLUDED_)
#define AFX_ADVENTTHREAD_H__8B1329BA_7CF5_4B5D_9CB9_ACC60C9EAD53__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AdventThread.h : header file
//



/////////////////////////////////////////////////////////////////////////////
// CAdventThread thread

class CAdventThread : public CWinThread
{
	DECLARE_DYNCREATE(CAdventThread)
protected:
	CAdventThread();           // protected constructor used by dynamic creation

// Attributes
public:
  static CMutex m_Mutex;  // global mutex for the thread mapper thingy
  static CArray<CAdventThread *,CAdventThread *> m_aThreads;  // master list  o' threads

  static CString InitialWebPage();
    // use this function to return a startup web page and begin the game thread
  static CString NextWebPage(LPCSTR szCommand, LPCSTR szSession);
    // use this function to send 'szCommand' to the adventure program and
    // get back a 'refreshed' web page.

  static CString GetHistory(LPCSTR szSession);
    // use this function to return the text for a history display

  static void TerminateAll();
    // marks the 'terminate' flags and returns when the thread list is empty

  int SafeWriteOutput(LPCSTR szOut);
  void SafeWriteOutput(char cOut);

  CString SafeReadInput();  // reads a (well, THE) line of text

  BOOL GetExitFlag() { return(m_bExitFlag); }

  DWORD m_dwStartTick;      // current 'tick' for timeouts, etc.


protected:

  class CInInput
  {
    public:
      CInInput(long &lFlag)
      {
        InterlockedIncrement(&lFlag);
        m_plFlag = &lFlag;
      }
      ~CInInput()
      {
        InterlockedDecrement(m_plFlag);
      }
    protected:
      long *m_plFlag;
  };

  static CAdventThread *ThreadFromIdentifier(LPCSTR szIdentifier);
    // must lock mutex before calling this function

  long m_lInInputFlag;   // TRUE if I'm "in input" waiting for something

  CEvent m_Event;        // set event to send a page of output and wait for input

  CString m_csOutQueue;  // output queue is nothing more than a serialized string
  CString m_csInQueue;
  CString m_csSession;   // the unique identifier sent as part of a web page

  CString m_csLastPage;  // what I sent last time (for blank command input)

  CStringArray m_acsHistory;  // a history of inputs and outputs (they all go in!)
                              // when the total # of lines is "too much" I start trimming

  BYTE m_bExitFlag;      // TRUE if I'm going to end the thread.  When this is TRUE,
                         // the game has already ended, and I'm doing cleanup.

// Operations
public:

  BYTE *m_pGlobals;      // storage for global pointers - yeah, baby, yeah!



// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAdventThread)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CAdventThread();

	// Generated message map functions
	//{{AFX_MSG(CAdventThread)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ADVENTTHREAD_H__8B1329BA_7CF5_4B5D_9CB9_ACC60C9EAD53__INCLUDED_)
